{
#######################################################################################
#  // The MIT License (MIT):                                                          #
#                                                                                     #
#  Synapse Example - Server with multiple Clients                                     #
#  Copyright (c) 2014   Marcel Märtens                                                #
#                                                                                     #
#  Permission is hereby granted, free of charge, to any person obtaining a copy       #
#  of this software and associated documentation files (the "Software"), to deal      #
#  in the Software without restriction, including without limitation the rights       #
#  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell          #
#  copies of the Software, and to permit persons to whom the Software is              #
#  furnished to do so, subject to the following conditions:                           #
#                                                                                     #
#  The above copyright notice and this permission notice shall be included in         #
#  all copies or substantial portions of the Software.                                #
#                                                                                     #
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR         #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,           #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE        #
#  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER             #
#  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,      #
#  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN          #
#  THE SOFTWARE.                                                                      #
#######################################################################################
}

unit synapseexample_client;

{$mode objfpc}{$H+}

interface

uses
 Classes, SysUtils,synsock,blcksock;

type
  TClient = class;

  TOnClientRec = procedure(aClient:TClient;aMSG:String) of object;

  { TClient }

  {
   This is a Basic Client,
   a Client has a synapse Socket for Communication.
   It must be a Thread for receiving Messages (See Execute Method)
  }
  TClient = class(TThread)
    Socket: TTCPBlockSocket;
  protected
    procedure IReceivedSomething(aMSG:String); virtual;
  public
   onClientRec:TOnClientRec;
   procedure Send(aMSG:String);
   procedure Start(IP: String; Port: Integer);
   procedure Execute; override;
  end;

implementation

{ TClient }

procedure TClient.IReceivedSomething(aMSG: String);
begin
if assigned(onClientRec) then onClientRec(Self,aMSG);
end;

procedure TClient.Send(aMSG: String);
begin
Socket.SendBlock(aMSG);
end;

procedure TClient.Start(IP: String; Port: Integer);
begin
  Socket:= TTCPBlockSocket.Create;
  Socket.Connect(IP,InttoStr(Port));
  Self.Resume;
end;

procedure TClient.Execute;
var
  aMessage:String;
begin
while not Terminated do
      begin
      aMessage := Self.Socket.RecvBlock(1000);
      if Self.Socket.LastError = 0 then Self.IReceivedSomething(aMessage);
      end;
end;

end.

